const system = require("../system");
const settings = require("../../config/settings");
const uuidv4 = require('uuid/v4');
class CtlBase {
  constructor(gname, sname) {
    this.serviceName = sname;
    this.service = system.getObject("service." + gname + "." + sname);
    this.cacheManager = system.getObject("db.common.cacheManager");
  }
  static getServiceName(ClassObj) {

    return ClassObj["name"].substring(0, ClassObj["name"].lastIndexOf("Ctl")).toLowerCase() + "Sve";
  }
  async update(pobj, qobj, req) {
    const up = await this.service.update(pobj);
    return system.getResult(up);
  }
  async findAndCountAll(pobj, qobj, req) {
    //设置查询条件
    console.log(pobj)
    const apps = await this.service.findAndCountAll(pobj);
    return system.getResult(apps);
  }
  async refQuery(pobj, qobj, req) {
    return this.service.refQuery(pobj);
  }
  async setContextParams(pobj, qobj, req) {
    let custtags = req.headers["x-consumetag"]?req.headers["x-consumetag"].split("|"):null;
    //当自由用户注册时，需要根据前端传来的companykey,查询出公司，给companyid赋值
    req.xctx = {
      appkey: req.headers["xappkey"],//用于系统管理区分应用,比如角色
      companyid: custtags?custtags[0].split("_")[1]:null,
      password: custtags?custtags[1].split("_")[1]:null,
      username: req.headers["x-consumer-username"],
      credid: req.headers["x-credential-identifier"],
      companykey:req.headers["x-company-key"],//专用于自由用户注册,自由用户用于一定属于某个存在的公司
    }
    if(!req.xctx.appkey){
        return [-200,"请求头缺少应用x-app-key"]
    }else{
      let app=await this.cacheManager["AppCache"].cache(req.xctx.appkey);
      req.xctx.appid=app.id;
      pobj.app_id=app.id;//传递参数对象里注入app_id
    }
    //平台注册时，companyid，companykey都为空
    //自由注册时，companykey不能为空
    // if(!req.xctx.companyid && !req.xctx.companykey){
    //   return [-200,"请求头缺少应用x-app-key"]
    // }
    if(!req.xctx.companyid && req.xctx.companykey){
      let comptmp=await this.cacheManager["CompanyCache"].cache(req.xctx.companykey);
      req.xctx.companyid=comptmp.id;
    }
    if(req.xctx.companyid){//在请求传递数据对象注入公司id
      pobj.company_id=req.xctx.companyid;
    }
  }
  async doexec(methodname, pobj, query, req) {
    try {
      let xarg=await this.setContextParams(pobj, query, req);
      if(xarg && xarg[0]<0){
         return system.getResultFail(...xarg);
      }
      //从请求头里面取appkey_consumename
      // var consumeName=req.headers[""]
      // var appkey=
      // if( this.session["appkey_consumename"]) {

      // }else{
      //   //从头里取，从redis中取出缓存对象赋值到控制基类的session属性
      //   //appkey_consumename
      //   this.session={};
      // }
      //req.session=redis缓存的上下文对象
      var rtn = await this[methodname](pobj, query, req);
      return rtn;
    } catch (e) {
      console.log(e.stack, "出现异常，请联系管理员.......");
      return system.getResultFail(-200, "出现异常，请联系管理员");
    }
  }
}
module.exports = CtlBase;
